/*
 * dll_mbsnrtowcs_locale ()
 * for conversion from multibyte character to UCS-4
 * programed
 *   by A. Yoshiyama (yosshy@jedi.seg.kobe-u.ac.jp)
 *   on Dec.17,1996
 */

#include <wchar.h>
#include <wcsmbs_locale.h>
#include <automaton.h>
#include <table_2_ucs2.h>
#include <errno.h>

#ifndef EILSEQ
#define EILSEQ EINVAL
#endif

static mbstate_t internal;

size_t
dll_mbsnrtowcs_locale (dst, src, nmc, len, ps)
     wchar_t *dst;
     const char **src;
     size_t nmc;
     size_t len;
     mbstate_t *ps;
{
  size_t written = 0;
  const unsigned char *run = *src;
  unsigned int pointer, defaultpointer;

  if (ps == NULL)
      ps = &internal;

  pointer = (unsigned int)ps->count;
  defaultpointer = (unsigned int)ps->value;
  
  if (src == NULL || *src == NULL)
    {
      ps->count = 0;
      ps->value = (wint_t)0;
      return (size_t) defaultpointer;
    }
  
  if (dst == NULL)
    len = ~0;
  
  for (; (written < len) && (nmc -- > 0); run++)
    if (*run == 0)
      /* The whole sequence is read.  Check whether end of string is
	 reached.  */
      {
	*src = NULL;
	if (dst != NULL)
	  *dst = (wchar_t)0;
	ps->count = 0;
	ps->value = (wint_t) 0;
	return written;
      }
    else
      {
	while (table_2_ucs2[pointer] != 0)
	  {
	    if (table_2_ucs2[pointer+1] & FLAG_DEFAULT)
	    defaultpointer = pointer;
	    
	    if (*run == table_2_ucs2[pointer])
	      if (table_2_ucs2[pointer+1] & FLAG_CODE)
		{
		  if (dst != NULL)
		    *dst++ = ((wchar_t)table_2_ucs2[pointer+2]) << 8 |
		      table_2_ucs2[pointer+3];
		  written ++;
		  pointer = defaultpointer;
		  goto exit_while;
		}
	      else
		{
		  pointer =
		    (((unsigned int)table_2_ucs2[pointer+1]) & 0x0F) << 16
		      | ((unsigned int)table_2_ucs2[pointer+2]) << 8
			|  (unsigned int)table_2_ucs2[pointer+3];
		  goto exit_while;
		}
	    else
	      if (table_2_ucs2[pointer+1] & FLAG_CODE)
		pointer += FINAL_NODE_SIZE;
	      else
		pointer += TRANSITION_NODE_SIZE;

	  }  /* end of while() */

	__set_errno(EILSEQ);
	return (size_t)-1;
	
      exit_while:
      }  /* end of if (*run == 0) ... else */

  *src = run;
  ps->count = (int) pointer;
  ps->value = (wint_t) defaultpointer;
  
  return written;
}
